## python3.10 3.10.4

=== Doc/Makefile ===
#
# Makefile for Python documentation
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#

# You can set these variables from the command line.
PYTHON       = python3
VENVDIR      = ./venv
SPHINXBUILD  = PATH=$(VENVDIR)/bin:$$PATH sphinx-build
BLURB        = PATH=$(VENVDIR)/bin:$$PATH blurb
PAPER        =
SOURCES      =
DISTVERSION  = $(shell $(PYTHON) tools/extensions/patchlevel.py)
SPHINXERRORHANDLING = -W

# Internal variables.
PAPEROPT_a4     = -D latex_elements.papersize=a4paper
PAPEROPT_letter = -D latex_elements.papersize=letterpaper

ALLSPHINXOPTS = -b $(BUILDER) -d build/doctrees $(PAPEROPT_$(PAPER)) \
                $(SPHINXOPTS) $(SPHINXERRORHANDLING) . build/$(BUILDER) $(SOURCES)

.PHONY: help build html htmlhelp latex text texinfo changes linkcheck \
	suspicious coverage doctest pydoc-topics htmlview clean dist check serve \
	autobuild-dev autobuild-stable venv

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  clean      to remove build files"
	@echo "  venv       to create a venv with necessary tools"
	@echo "  html       to make standalone HTML files"
	@echo "  htmlview   to open the index page built by the html target in your browser"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  text       to make plain text files"
	@echo "  texinfo    to make Texinfo file"
	@echo "  epub       to make EPUB files"
	@echo "  changes    to make an overview over all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  coverage   to check documentation coverage for library and C API"
	@echo "  doctest    to run doctests in the documentation"
	@echo "  pydoc-topics  to regenerate the pydoc topics file"
	@echo "  dist       to create a \"dist\" directory with archived docs for download"
	@echo "  suspicious to check for suspicious markup in output text"
	@echo "  check      to run a check for frequent markup errors"
	@echo "  serve      to serve the documentation on the localhost (8000)"

build:
	-mkdir -p build
# Look first for a Misc/NEWS file (building from a source release tarball
# or old repo) and use that, otherwise look for a Misc/NEWS.d directory
# (building from a newer repo) and use blurb to generate the NEWS file.
	@if [ -f  ../Misc/NEWS ] ; then \
		echo "Using existing Misc/NEWS file"; \
		cp ../Misc/NEWS build/NEWS; \
	elif $(BLURB) help >/dev/null 2>&1 && $(SPHINXBUILD) --version >/dev/null 2>&1; then \
		if [ -d ../Misc/NEWS.d ]; then \
			echo "Building NEWS from Misc/NEWS.d with blurb"; \
			$(BLURB) merge -f build/NEWS; \
		else \
			echo "Neither Misc/NEWS.d nor Misc/NEWS found; cannot build docs"; \
			exit 1; \
		fi \
	else \
		echo ""; \
		echo "Missing the required blurb or sphinx-build tools."; \
		echo "Please run 'make venv' to install local copies."; \
		echo ""; \
		exit 1; \
	fi
	$(SPHINXBUILD) $(ALLSPHINXOPTS)
	@echo

html: BUILDER = html
html: build
	@echo "Build finished. The HTML pages are in build/html."

htmlhelp: BUILDER = htmlhelp
htmlhelp: build
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      "build/htmlhelp/pydoc.hhp project file."

latex: BUILDER = latex
latex: build
	@echo "Build finished; the LaTeX files are in build/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

text: BUILDER = text
text: build
	@echo "Build finished; the text files are in build/text."

texinfo: BUILDER = texinfo
texinfo: build
	@echo "Build finished; the python.texi file is in build/texinfo."
	@echo "Run \`make info' in that directory to run it through makeinfo."

epub: BUILDER = epub
epub: build
	@echo "Build finished; the epub files are in build/epub."

changes: BUILDER = changes
changes: build
	@echo "The overview file is in build/changes."

linkcheck: BUILDER = linkcheck
linkcheck:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Link check complete; look for any errors in the above output" \
	     "or in build/$(BUILDER)/output.txt"; \
	false; }

suspicious: BUILDER = suspicious
suspicious:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Suspicious check complete; look for any errors in the above output" \
	     "or in build/$(BUILDER)/suspicious.csv.  If all issues are false" \
	     "positives, append that file to tools/susp-ignored.csv."; \
	false; }

coverage: BUILDER = coverage
coverage: build
	@echo "Coverage finished; see c.txt and python.txt in build/coverage"

doctest: BUILDER = doctest
doctest:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Testing of doctests in the sources finished, look at the" \
	     "results in build/doctest/output.txt"; \
	false; }

pydoc-topics: BUILDER = pydoc-topics
pydoc-topics: build
	@echo "Building finished; now run this:" \
	      "cp build/pydoc-topics/topics.py ../Lib/pydoc_data/topics.py"

htmlview: html
	 $(PYTHON) -c "import webbrowser; webbrowser.open('build/html/index.html')"

clean: clean-venv
	-rm -rf build/*

clean-venv:
	rm -rf $(VENVDIR)

venv:
	@if [ -d $(VENVDIR) ] ; then \
		echo "venv already exists."; \
		echo "To recreate it, remove it first with \`make clean-venv'."; \
	else \
		$(PYTHON) -m venv $(VENVDIR); \
		$(VENVDIR)/bin/python3 -m pip install -U pip setuptools; \
		$(VENVDIR)/bin/python3 -m pip install -r requirements.txt; \
		echo "The venv has been created in the $(VENVDIR) directory"; \
	fi

dist:
	rm -rf dist
	mkdir -p dist

	# archive the HTML
	make html
	cp -pPR build/html dist/python-$(DISTVERSION)-docs-html
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-html.tar python-$(DISTVERSION)-docs-html
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-html.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-html.zip python-$(DISTVERSION)-docs-html)
	rm -r dist/python-$(DISTVERSION)-docs-html
	rm dist/python-$(DISTVERSION)-docs-html.tar

	# archive the text build
	make text
	cp -pPR build/text dist/python-$(DISTVERSION)-docs-text
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-text.tar python-$(DISTVERSION)-docs-text
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-text.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-text.zip python-$(DISTVERSION)-docs-text)
	rm -r dist/python-$(DISTVERSION)-docs-text
	rm dist/python-$(DISTVERSION)-docs-text.tar

	# archive the A4 latex
	rm -rf build/latex
	make latex PAPER=a4
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-a4.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-a4.tar.bz2

	# archive the letter latex
	rm -rf build/latex
	make latex PAPER=letter
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-letter.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-letter.tar.bz2

	# copy the epub build
	rm -rf build/epub
	make epub
	cp -pPR build/epub/Python.epub dist/python-$(DISTVERSION)-docs.epub

	# archive the texinfo build
	rm -rf build/texinfo
	make texinfo
	make info --directory=build/texinfo
	cp -pPR build/texinfo dist/python-$(DISTVERSION)-docs-texinfo
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-texinfo.tar python-$(DISTVERSION)-docs-texinfo
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-texinfo.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-texinfo.zip python-$(DISTVERSION)-docs-texinfo)
	rm -r dist/python-$(DISTVERSION)-docs-texinfo
	rm dist/python-$(DISTVERSION)-docs-texinfo.tar

check:
	$(PYTHON) tools/rstlint.py -i tools -i $(VENVDIR) -i README.rst
	$(PYTHON) tools/rstlint.py ../Misc/NEWS.d/next/

serve:
	$(PYTHON) ../Tools/scripts/serve.py build/html

# Targets for daily automated doc build
# By default, Sphinx only rebuilds pages where the page content has changed.
# This means it doesn't always pick up changes to preferred link targets, etc
# To ensure such changes are picked up, we build the published docs with
# `-E` (to ignore the cached environment) and `-a` (to ignore already existing
# output files)

# for development releases: always build
autobuild-dev:
	make dist SPHINXOPTS='$(SPHINXOPTS) -Ea -A daily=1'

# for quick rebuilds (HTML only)
autobuild-dev-html:
	make html SPHINXOPTS='$(SPHINXOPTS) -Ea -A daily=1'

# for stable releases: only build if not in pre-release stage (alpha, beta)
# release candidate downloads are okay, since the stable tree can be in that stage
autobuild-stable:
	@case $(DISTVERSION) in *[ab]*) \
		echo "Not building; $(DISTVERSION) is not a release version."; \
		exit 1;; \
	esac
	@make autobuild-dev

autobuild-stable-html:
	@case $(DISTVERSION) in *[ab]*) \
		echo "Not building; $(DISTVERSION) is not a release version."; \
		exit 1;; \
	esac
	@make autobuild-dev-html

=== Doc/requirements.txt ===
# Requirements to build the Python documentation

# Sphinx version is pinned so that new versions that introduce new warnings
# won't suddenly cause build failures. Updating the version is fine as long
# as no warnings are raised by doing so.
sphinx==3.2.1
# Docutils version is pinned to a version compatible with Sphinx
# version 3.2.1. It can be removed after bumping Sphinx version to at
# least 3.5.4.
docutils==0.17.1

blurb

# The theme used by the documentation is stored separately, so we need
# to install that as well.
python-docs-theme>=2022.1

## python3.10 3.10.0~a7

=== debian/changelog ===
python3.10 (3.10.0~a7-3) experimental; urgency=medium

  * Build a python3.10-full package.

 -- Matthias Klose <doko@debian.org>  Tue, 06 Apr 2021 17:05:58 +0200

python3.10 (3.10.0~a7-1) experimental; urgency=medium

  * Python 3.10.0 alpha 7 snapshot.
  * Depend on media-types instead of mime-support. Addresses: #981016.
  * Fix permissions and group for local directories. Addresses: #962422.
  * Revert the fix for issue 42856 for now, need to update patches, to
    not require particular wheel versions.
  * Update symbols files.
  * Move zlib1g-dev dependency to libpython3.9-dev. Addresses: #984580.
  * Configure with --libdir=/usr/lib/$(DEB_HOST_MULTIARCH), recording the
    correct LIBDIR in _sysconfigdata.  Also adjust DESTSHARED to install
    lib-dynload into the same location as before the configure change.
    See issue #43229.
  * Fix flags substitutions for _sysconfigdata.
  * Autopkg tests:
    - Run testsuite{,-dbg} autopkg tests with allow-stderr. Closes: #983305.
    - Run again in testsuite instead of failing-tests: test_ftplib,
      test_httplib test_imaplib test_nntplib test_poplib test_ssl.
    - Run test_distutils and test_site tests again.
  * Build idlelib/help.html from source, don't ship the pre-generated file.

 -- Matthias Klose <doko@debian.org>  Tue, 06 Apr 2021 14:56:07 +0200

python3.10 (3.10.0~a4-2) experimental; urgency=medium

  * Configure again --with-system-libmpdec.

 -- Matthias Klose <doko@debian.org>  Mon, 11 Jan 2021 11:15:34 +0100

python3.10 (3.10.0~a4-1) experimental; urgency=medium

  * Python 3.10.0 alpha 4 snapshot.
  * Update symbols files.

 -- Matthias Klose <doko@debian.org>  Sun, 10 Jan 2021 14:40:53 +0100

python3.10 (3.10.0~a3-1) experimental; urgency=medium

  * Python 3.10.0 alpha 3 snapshot.
  * Update symbols files.

 -- Matthias Klose <doko@debian.org>  Tue, 08 Dec 2020 14:18:31 +0100

python3.10 (3.10.0~a2-1) experimental; urgency=medium

  * Python 3.10.0 alpha 2 snapshot.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 07 Nov 2020 09:09:33 +0100

python3.9 (3.9.0-5~20.04) focal-proposed; urgency=medium

  * SRU: LP: #1899954. Backport Python 3.9.0 to 20.04 LTS.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 20 Oct 2020 10:43:38 +0200

python3.9 (3.9.0-5) unstable; urgency=medium

  * Update to the 3.9 branch 2020-10-19.
  * python3.9-venv: Depend on python3-distutils.

 -- Matthias Klose <doko@debian.org>  Mon, 19 Oct 2020 11:51:18 +0200

python3.9 (3.9.0-4) unstable; urgency=medium

  * Fix module-install-venv autopkg test dependency.

 -- Matthias Klose <doko@debian.org>  Sun, 18 Oct 2020 11:42:38 +0200

python3.9 (3.9.0-3) unstable; urgency=high

  * Update to the 3.9 branch 2020-10-16.
  * ensurepip: Don't try to import the _bundled module.
  * Refresh patches.
  * Add some autopkg tests for venv (Stefano Rivera).

 -- Matthias Klose <doko@debian.org>  Fri, 16 Oct 2020 19:57:59 +0200

python3.9 (3.9.0-2) unstable; urgency=medium

  * Update to the 3.9 branch 2020-10-15.
  * Build with -O1 on sh4 (Adrian Glaubitz). Closes: #972202.
  * Don't run test_ttk_guionly test, timing on many buildds.

 -- Matthias Klose <doko@debian.org>  Thu, 15 Oct 2020 13:54:52 +0200

python3.9 (3.9.0-1) unstable; urgency=medium

  * Python 3.9.0 release.

 -- Matthias Klose <doko@debian.org>  Mon, 05 Oct 2020 22:56:51 +0200

python3.9 (3.9.0~rc2-1) unstable; urgency=medium

  * Python 3.9.0 release candidate 2.

 -- Matthias Klose <doko@debian.org>  Thu, 17 Sep 2020 12:40:00 +0200

python3.9 (3.9.0~rc1-1) unstable; urgency=medium

  * Python 3.9.0 release candidate 1.

 -- Matthias Klose <doko@debian.org>  Wed, 12 Aug 2020 12:42:16 +0200

python3.9 (3.9.0~b5-2) unstable; urgency=medium

  * Move typing.py into libpython3.9-minimal.

 -- Matthias Klose <doko@debian.org>  Thu, 23 Jul 2020 11:11:14 +0200

python3.9 (3.9.0~b5-1) unstable; urgency=medium

  * Python 3.9.0 beta 5.

 -- Matthias Klose <doko@debian.org>  Wed, 22 Jul 2020 11:03:53 +0200

python3.9 (3.9.0~b4-2) unstable; urgency=medium

  * Fix symbols file on i386.
  * Don't run test_concurrent_futures on riscv64, takes ages.

 -- Matthias Klose <doko@debian.org>  Thu, 16 Jul 2020 13:24:24 +0200

python3.9 (3.9.0~b4-1) unstable; urgency=medium

  * Python 3.9.0 beta 4.

 -- Matthias Klose <doko@debian.org>  Mon, 06 Jul 2020 15:22:12 +0200

python3.8 (3.8.4~rc1-1) unstable; urgency=medium

  * Python 3.8.4 release candidate 1.

 -- Matthias Klose <doko@debian.org>  Wed, 01 Jul 2020 17:31:45 +0200

python3.8 (3.8.3-1) unstable; urgency=medium

  * Python 3.8.3 release.
  * Add XB-Cnf-Visible-Pkgname header on the python*-minimal package to
    point command-not-found at the full one. LP: #1867157

 -- Matthias Klose <doko@debian.org>  Thu, 14 May 2020 13:03:12 +0200

python3.8 (3.8.3~rc1-1) unstable; urgency=medium

  * Python 3.8.3 release candidate 1.
    - Issue #38576, CVE-2019-18348: Disallow control characters in hostnames
      in http.client.
    - Issue #39503, CVE-2020-8492: Denial of service in
      urllib.request.AbstractBasicAuthHandler.

 -- Matthias Klose <doko@debian.org>  Thu, 30 Apr 2020 09:33:30 +0200

python3.8 (3.8.2-1) unstable; urgency=medium

  * Python 3.8.2 release.

 -- Matthias Klose <doko@debian.org>  Tue, 25 Feb 2020 14:04:52 +0100

python3.8 (3.8.2~rc2-2) unstable; urgency=medium

  * Ignore some autopkg test failures:
    - test_ssl: Fails with OPENSSL_TLS_SECURITY_LEVEL=2.
    - test_io: Fails on Ubuntu's autopkg test infrastructure.
    - Lower OpenSSL security level from 2 to 1 during testing as test_ssl
      assumes that (Dimitri John Ledkov).

 -- Matthias Klose <doko@debian.org>  Fri, 21 Feb 2020 12:37:41 +0100

python3.8 (3.8.2~rc2-1) unstable; urgency=medium

  * Python 3.8.2 release candidate 2.

 -- Matthias Klose <doko@debian.org>  Tue, 18 Feb 2020 11:16:50 +0100

python3.8 (3.8.2~rc1-1) unstable; urgency=medium

  * Python 3.8.2 release candidate 1.
  * Make autopkgtests cross-test-friendly (Steve Langasek).
  * Bump standards version.



=== debian/control ===
Source: python3.10
Section: python
Priority: optional
Maintainer: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.17.11),
  quilt, autoconf,
  lsb-release, sharutils,
  libreadline-dev, libncursesw5-dev (>= 5.3), 
  zlib1g-dev, libbz2-dev, liblzma-dev,
  libgdbm-dev, libdb-dev,
  tk-dev, blt-dev (>= 2.4z), libssl-dev,
  libexpat1-dev, libmpdec-dev (>= 2.5.1~),
  libbluetooth-dev [linux-any] <!pkg.python3.10.nobluetooth>,
  locales-all,
  libsqlite3-dev, libffi-dev (>= 3.0.5) [!or1k !avr32],
  libgpm2 [linux-any],
  media-types | mime-support, netbase, bzip2, time, python3:any, python3.10:any <cross>,
  net-tools, xvfb <!nocheck>, xauth <!nocheck>,
  systemtap-sdt-dev
Build-Depends-Indep: python3-sphinx, python3-docs-theme, texinfo
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/cpython-team/python3
Vcs-Git: https://salsa.debian.org/cpython-team/python3.git
XS-Testsuite: autopkgtest

Package: python3.10
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.10-minimal (= ${binary:Version}),
 libpython3.10-stdlib (= ${binary:Version}),
 media-types | mime-support,
 ${shlibs:Depends}, ${misc:Depends}
Suggests: python3.10-venv, python3.10-doc, binutils
Breaks: python3-all (<< 3.6.5~rc1-1),
  python3-dev (<< 3.6.5~rc1-1),
  python3-venv (<< 3.6.5-2)
Description: Interactive high-level object-oriented language (version 3.10)
 Python is a high-level, interactive, object-oriented language. Its 3.10 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.

Package: python3.10-venv
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.10 (= ${binary:Version}),
 python-pip-whl (>= 8.1.0-2),
 python3.10-distutils,
 ${shlibs:Depends}, ${misc:Depends},
Breaks: python3-pip (<< 1.5.6-4)
Description: Interactive high-level object-oriented language (pyvenv binary, version 3.10)
 Python is a high-level, interactive, object-oriented language. Its 3.10 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the pyvenv-3.10 binary.

Package: libpython3.10-stdlib
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.10-minimal (= ${binary:Version}), mime-support, ${shlibs:Depends}, ${misc:Depends}
Description: Interactive high-level object-oriented language (standard library, version 3.10)
 Python is a high-level, interactive, object-oriented language. Its 3.10 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains Python 3.10's standard library. It is normally not
 used on its own, but as a dependency of python3.10.

Package: python3.10-minimal
Architecture: any
Multi-Arch: allowed
Priority: optional
Pre-Depends: ${shlibs:Pre-Depends}
Depends: libpython3.10-minimal (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: python3.10
Suggests: binfmt-support
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 3.10)
 This package contains the interpreter and some essential modules.  It can
 be used in the boot process for some basic tasks.
 See /usr/share/doc/python3.10-minimal/README.Debian for a list of the modules
 contained in this package.
XB-Cnf-Visible-Pkgname: python3.10

Package: libpython3.10-minimal
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libpython3.10-stdlib
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 3.10)
 This package contains some essential modules. It is normally not
 used on it's own, but as a dependency of python3.10-minimal.

Package: libpython3.10
Architecture: any
Multi-Arch: same
Section: libs
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.10-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Shared Python runtime library (version 3.10)
 Python is a high-level, interactive, object-oriented language. Its 3.10 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the shared runtime library, normally not needed
 for programs using the statically linked interpreter.

Package: python3.10-examples
Architecture: all
Depends: python3.10:any (>= ${source:Version}), ${misc:Depends}
Description: Examples for the Python language (v3.10)
 Examples, Demos and Tools for Python (v3.10). These are files included in
 the upstream Python distribution (v3.10).

Package: python3.10-dev
Architecture: any
Multi-Arch: allowed
Depends: python3.10 (= ${binary:Version}),
  libpython3.10-dev (= ${binary:Version}),
  libpython3.10 (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.10)
 Header files, a static library and development tools for building
 Python (v3.10) modules, extending the Python interpreter or embedding
 Python (v3.10) in applications.
 .
 Maintainers of Python packages should read README.maintainers.

Package: libpython3.10-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.10-stdlib (= ${binary:Version}),
  libpython3.10 (= ${binary:Version}),
  libexpat1-dev, zlib1g-dev,
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.10)
 Header files, a static library and development tools for building
 Python (v3.10) modules, extending the Python interpreter or embedding
 Python (v3.10) in applications.
 .
 Maintainers of Python packages should read README.maintainers.
 .
 This package contains development files. It is normally not
 used on it's own, but as a dependency of python3.10-dev.

Package: libpython3.10-testsuite
Section: libdevel
Architecture: all
Depends: python3.10 (>= ${binary:Version}), ${misc:Depends}, net-tools
Suggests: python3-gdbm, python3-tk
Description: Testsuite for the Python standard library (v3.10)
 The complete testsuite for the Python standard library.  Note that
 a subset is found in the libpython3.10-stdlib package, which should
 be enough for other packages to use (please do not build-depend
 on this package, but file a bug report to include additional 
 testsuite files in the libpython3.10-stdlib package).

Package: idle-python3.10
Architecture: all
Depends: python3.10, python3-tk, python3.10-tk,
  ${misc:Depends},
  libjs-mathjax,
Enhances: python3.10
Description: IDE for Python (v3.10) using Tkinter
 IDLE is an Integrated Development Environment for Python (v3.10).
 IDLE is written using Tkinter and therefore quite platform-independent.

Package: python3.10-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-jquery, libjs-underscore, ${misc:Depends}
Suggests: python3.10
Description: Documentation for the high-level object-oriented language Python (v3.10)
 These is the official set of documentation for the interactive high-level
 object-oriented language Python (v3.10). All documents are provided
 in HTML format. The package consists of ten documents:
 .
   * What's New in Python3.10
   * Tutorial
   * Python Library Reference
   * Macintosh Module Reference
   * Python Language Reference
   * Extending and Embedding Python
   * Python/C API Reference
   * Installing Python Modules
   * Documenting Python
   * Distributing Python Modules

Package: python3.10-dbg
Section: debug
Architecture: any
Multi-Arch: allowed
Depends: python3.10 (= ${binary:Version}), libpython3.10-dbg (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: gdb
Suggests: python3-gdbm-dbg, python3-tk-dbg
Description: Debug Build of the Python Interpreter (version 3.10)
 The package holds two things:
 .
 - A Python interpreter configured with --pydebug. Dynamically loaded modules
   are searched as <foo>_d.so first. Third party extensions need a separate
   build to be used by this interpreter.
 - Debug information for standard python interpreter and extensions.
 .
 See the README.debug for more information.

Package: libpython3.10-dbg
Section: debug
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.10-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Debug Build of the Python Interpreter (version 3.10)
 The package holds two things:
 .
 - Extensions for a Python interpreter configured with --pydebug.
 - Debug information for standard python extensions.
 .
 See the README.debug for more information.

Package: python3.10-full
Architecture: any
Multi-Arch: allowed
Depends: python3.10 (= ${binary:Version}),
  libpython3.10-testsuite,
  python3.10-venv (= ${binary:Version}),
  idle-python3.10,
  python3.10-distutils,
  python3.10-gdbm,
  python3.10-lib2to3,
  python3.10-tk,
  ca-certificates,
  ${shlibs:Depends}, ${misc:Depends}
Recommends: python3.10-doc, python3.10-examples,
Suggests: python3.10-dev
Description: Python Interpreter with complete class library (version 3.10)
 Python, the high-level, interactive object oriented language,
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package is a dependency package, which depends on the full
 standard library of Python for Python developers. Including modules
 used only at build-time, such as venv and distutils, and modules with
 complex dependencies, such as tk and IDLE. All batteries included.
 .
 According to the Debian Python policy, this package must not be used in
 build dependencies, dependencies and recommendations.

=== debian/rules ===
#!/usr/bin/make -f

unexport LANG LC_ALL LC_CTYPE LC_COLLATE LC_TIME LC_NUMERIC LC_MESSAGES
unexport CFLAGS CXXFLAGS LDFLAGS CPPFLAGS

export DEB_BUILD_MAINT_OPTIONS=hardening=-pie
dpkg_buildflags = DEB_BUILD_MAINT_OPTIONS=$(DEB_BUILD_MAINT_OPTIONS) dpkg-buildflags

export SHELL = /bin/bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

vafilt		= $(subst $(2)=,,$(filter $(2)=%,$(1)))
DPKG_VARS	:= $(shell dpkg-architecture)
DEB_BUILD_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_ARCH)
DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_HOST_ARCH_ENDIAN	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_ENDIAN)
DEB_HOST_ARCH_OS	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_OS)
DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)

ifeq ($(DEB_HOST_ARCH_OS),linux)
  PLAT = linux
else ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
  PLAT = gnukfreebsd10
else ifeq ($(DEB_HOST_ARCH_OS),hurd)
  PLAT = gnu0
else
  $(warning unhandled operating system name: $(DEB_HOST_ARCH_OS))
  PLAT = unknown
endif

CHANGELOG_VARS := $(shell dpkg-parsechangelog | \
	sed -n 's/ /_/g;/^[^_]/s/^\([^:]*\):_\(.*\)/\1=\2/p')
PKGSOURCE  := $(call vafilt,$(CHANGELOG_VARS),Source)
PKGVERSION := $(call vafilt,$(CHANGELOG_VARS),Version)

LAST_CHANGE := $(shell dpkg-parsechangelog -S Date)
export BUILD_DATE := $(shell LC_ALL=C date -u +'%b %e %Y' -d '$(LAST_CHANGE)')
export BUILD_TIME := $(shell LC_ALL=C date -u +'%H:%M:%S' -d '$(LAST_CHANGE)')

SPHINXOPTS := -D today='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
SPHINXOPTS += -D html_last_updated_fmt='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
export SPHINXOPTS

on_buildd := $(shell [ -f /CurrentlyBuilding -o "$$LOGNAME" = buildd -o "$$USER" = buildd ] && echo yes)

dh_compat2 := $(shell dpkg --compare-versions "$$(dpkg-query -f '$${Version}' -W debhelper)" lt 9.20150811ubuntu2 && echo DH_COMPAT=2)

ifneq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
  WITHOUT_CHECK := yes
endif
WITHOUT_BENCH :=
ifneq (,$(findstring nobench, $(DEB_BUILD_OPTIONS)))
  WITHOUT_BENCH := yes
endif
ifeq ($(on_buildd),yes)
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el riscv64 s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
    WITHOUT_CHECK := yes
  endif
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el riscv64 s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
    WITHOUT_BENCH := yes
  endif
endif
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  WITHOUT_BENCH := yes
  WITHOUT_CHECK := yes
endif

COMMA = ,
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

distribution := $(shell lsb_release -is)
distrelease  := $(shell lsb_release -cs)
derivative      := $(shell \
	if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
	elif dpkg-vendor --derives-from Debian; then echo Debian; \
	else echo Unknown; fi)

VER=3.10
SVER=3.10.0~a4
NVER=3.11
PVER=python$(VER)
EXT_VER=$(subst .,,$(VER))
PRIORITY=$(shell echo $(VER) | tr -d '.')0

PREVVER	:= $(shell awk '/^python/ && NR > 1 {print substr($$2,2,length($$2)-2); exit}' debian/changelog)

# default versions are built from the python-defaults source package
# keep the definition to adjust package priorities.
DEFAULT_VERSION = no
STATIC_PYTHON=yes

MIN_MODS := $(shell awk '/^  / && $$2 == "module" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_EXTS := $(shell awk '/^  / && $$2 ~ /^extension/ { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_BUILTINS := $(shell awk '/^  / && $$2 == "builtin" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_PACKAGES := $(shell awk '/^  / && $$2 == "package" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_ENCODINGS := $(foreach i, \
			$(filter-out \
			  big5% bz2% cp932.py cp949.py cp950.py euc_% \
			  gb% iso2022% johab.py shift_jis% , \
			  $(shell cd Lib/encodings && echo *.py)), \
			encodings/$(i)) \
		 codecs.py stringprep.py

with_tk := no
with_interp := static
#with_interp := shared

PY_INTERPRETER = /usr/bin/python$(VER)

ifeq ($(DEFAULT_VERSION),yes)
  PY_PRIO = standard
  #PYSTDDEP = , python (>= $(VER))
else
  PY_PRIO = optional
endif
ifeq ($(distribution),Ubuntu)
  PY_MINPRIO = required
  PY_MINPRIO = optional
  #with_udeb = yes
  # test_ssl assumes that openssl is compiled with security level set to 1
  # make it so, during the build
  export OPENSSL_CONF = $(CURDIR)/debian/openssl.cnf
else
  PY_MINPRIO = $(PY_PRIO)
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  bd_qual = :any
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  ma_filter = cat
else
  ma_filter = grep -v '^Multi-Arch:'
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric precise quantal raring saucy trusty))
  bd_dpkgdev = dpkg-dev (>= 1.17.11),
endif

CC=$(DEB_HOST_GNU_TYPE)-gcc
CXX=$(DEB_HOST_GNU_TYPE)-g++
ifneq (,$(filter $(distrelease),bionic))
  CC=$(DEB_HOST_GNU_TYPE)-gcc-8
  CXX=$(DEB_HOST_GNU_TYPE)-g++-8
  bd_gcc = g++-8,
endif

AR=$(DEB_HOST_GNU_TYPE)-ar
RANLIB=$(DEB_HOST_GNU_TYPE)-ranlib

# configure and dtrace consume these
export CC CXX

DPKG_CPPFLAGS= $(shell $(dpkg_buildflags) --get CPPFLAGS)
DPKG_CFLAGS  := $(shell $(dpkg_buildflags) --get CFLAGS)
DPKG_CFLAGS  := $(subst -fstack-protector-strong,-fstack-protector,$(DPKG_CFLAGS))
DPKG_LDFLAGS = $(shell $(dpkg_buildflags) --get LDFLAGS)
OPT_CFLAGS   := $(filter-out -O%,$(DPKG_CFLAGS)) # default is -O3
DEBUG_CFLAGS := $(patsubst -O%,-Og,$(DPKG_CFLAGS))

# on ia64, disable -O3 until gcc bug #85412 is fixed
ifeq ($(DEB_HOST_ARCH),ia64)
    EXTRA_OPT_CFLAGS += -O2
endif
# see #972202
ifeq ($(DEB_HOST_ARCH),sh4)
    EXTRA_OPT_CFLAGS += -O1
endif
ifneq (,$(filter $(DEB_HOST_ARCH), ppc64 ppc64el))
    OPT_CFLAGS += -fexceptions
    DEBUG_CFLAGS += -fexceptions
endif

ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  ifeq ($(DEB_HOST_ARCH_OS),linux)
    ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf arm64 i386 powerpc ppc64 ppc64el s390x))
      with_pgo := yes
    endif
  endif
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf arm64 i386 powerpc ppc64 ppc64el s390x))
  with_lto := yes
endif

ifneq (,$(findstring nopgo, $(DEB_BUILD_OPTIONS)))
  with_pgo :=
endif

with_pgo := disabled for now
with_lto := disabled for now

ifneq (,$(findstring nolto, $(DEB_BUILD_OPTIONS)))
  with_lto :=
endif

ifneq (,$(findstring noopt, $(DEB_BUILD_OPTIONS)))
    OPT_CFLAGS := $(filter-out -O%, $(OPT_CFLAGS))
    EXTRA_OPT_CFLAGS = -O0
    with_pgo =
    with_lto =
endif

BASE_LTO_CFLAGS = -g -fwrapv -O3
ifeq ($(with_lto),yes)
    LTO_CFLAGS = $(BASE_LTO_CFLAGS) -flto -fuse-linker-plugin
    with_fat_lto := $(shell dpkg --compare-versions $$($(CC) --version \
			| sed -n '/^$(CC)/s,.* ,,p') ge 4.9 && echo yes)
    ifeq ($(with_fat_lto),yes)
      LTO_CFLAGS += -ffat-lto-objects
    endif
    EXTRA_OPT_CFLAGS += $(LTO_CFLAGS)
    AR=$(DEB_HOST_GNU_TYPE)-gcc-ar
    RANLIB=$(DEB_HOST_GNU_TYPE)-gcc-ranlib
endif

sysconfig_substflags = \
	-e 's,gcc-8,gcc,;s,g++-8,g++,' \
	$(if $(with_lto),$(foreach i,-flto=auto -flto -fuse-linker-plugin -ffat-lto-objects,-e 's/$(i)//g')) \
	-e '/^OPT/s,-O3,-O2,' \
	-e 's/-O3/-O2/g' \
	-e 's/-fprofile-use *-fprofile-correction//g' \
	-e 's/-fstack-protector /-fstack-protector-strong /g' \
	-e 's/-specs=[^ ]*//g' \
	-e 's/-fdebug-prefix-map=[^ ]*//g' \
	-e 's,^RUNSHARED *=.*,RUNSHARED=,' \
	-e '/BLDLIBRARY/s/-L\. //'

make_build_target = $(if $(filter yes, $(with_pgo)),profile-opt)

buildd_static	:= $(CURDIR)/build-static
buildd_shared	:= $(CURDIR)/build-shared
buildd_debug	:= $(CURDIR)/build-debug
buildd_shdebug	:= $(CURDIR)/build-shdebug

d		:= debian/tmp

=== debian/tests/control ===
Tests: testsuite
Depends: build-essential,
  ca-certificates,
  locales-all,
  python3.10-dev,
  libpython3.10-testsuite:native,
  python3-gdbm (>= 3.9.0),
  python3-distutils,
  python3-tk (>= 3.9.0),
  idle-python3.10,
  systemtap-sdt-dev,
# need to turn off apport
Restrictions: needs-root, allow-stderr

Tests: testsuite-dbg
Depends: build-essential,
  ca-certificates,
  locales-all, python3.10-dev,
  python3.10-dbg,
  libpython3.10-testsuite:native,
  python3-gdbm-dbg (>= 3.9.0),
  gdb,
  python3-distutils,
  python3-tk-dbg (>= 3.9.0),
  idle-python3.10,
  systemtap-sdt-dev,
# need to turn off apport
Restrictions: needs-root, allow-stderr

Tests: failing-tests
Depends: build-essential,
  ca-certificates,
  locales-all,
  python3.10-dev,
  libpython3.10-testsuite:native,
  python3-gdbm (>= 3.9.0),
  python3-tk (>= 3.9.0),
  python3-distutils,
  python3.9-venv,
# need to turn off apport
Restrictions: needs-root, allow-stderr

Tests: failing-tests-dbg
Depends: build-essential,
  ca-certificates,
  locales-all,
  python3.10-dev,
  python3.10-dbg,
  libpython3.10-testsuite:native,
  python3-gdbm-dbg (>= 3.9.0),
  python3-tk-dbg (>= 3.9.0),
  gdb,
  python3-distutils,
  python3.9-venv,
# need to turn off apport
Restrictions: needs-root, allow-stderr

Tests: module-install-local
Depends: build-essential, python3.10-dev, python3-setuptools, shunit2
Restrictions: needs-root

Tests: module-install-user
Depends: build-essential, python3.10-dev, python3-setuptools, shunit2

Tests: module-install-venv
Depends: build-essential, python3.10-dev, python3.10-venv, shunit2

#Tests: module-install-virtualenv
#Depends: build-essential, python3.10-dev, shunit2, virtualenv

## python3.10 3.10.0~b1

=== debian/changelog ===
python3.10 (3.10.0~b1-3~21.04) hirsute; urgency=medium

  * SRU: LP: #1928058, Backport 3.10.0 beta1 to 21.04.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 11 May 2021 10:45:09 +0200

python3.10 (3.10.0~b1-3) experimental; urgency=medium

  * Try to detect whether python3-venv is missing (Stefano Rivera).
    Closes: #977887.

 -- Matthias Klose <doko@debian.org>  Tue, 11 May 2021 08:19:33 +0200

python3.10 (3.10.0~b1-2) experimental; urgency=medium

  * Add the headers key to the added Debian INSTALL_SCHEMES.
  * Use libeditreadline-dev instead of libedit-dev as a build dependency.
  * Refresh patches.
  * When building 3.10 for releases newer than Debian 11 (bullseye) or
    Ubuntu 21.04 (hirsute), build the _dbm extension using gdbm, and
    include it in the python3-gdbm package.
    Raise an ImportError when trying to import the _dbm module, if the
    python3-gdbm package is not installed.
  * Call python with -S when checking the minimal set of modules.

 -- Matthias Klose <doko@debian.org>  Thu, 06 May 2021 11:07:08 +0200

python3.10 (3.10.0~b1-1) experimental; urgency=medium

  * Python 3.10.0 beta 1 snapshot.
  * Drop the unused build dependency on libdb-dev.
  * Prefer to build with libedit-dev instead of libreadline-dev. See #977732.
  * Update symbols files.

 -- Matthias Klose <doko@debian.org>  Tue, 04 May 2021 06:21:11 +0200

=== debian/control ===
--- 
+++ 
@@ -5,9 +5,9 @@
 Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.17.11),
   quilt, autoconf,
   lsb-release, sharutils,
-  libreadline-dev, libncursesw5-dev (>= 5.3), 
+  libeditreadline-dev | libreadline-dev, libncursesw5-dev (>= 5.3), 
   zlib1g-dev, libbz2-dev, liblzma-dev,
-  libgdbm-dev, libdb-dev,
+  libgdbm-dev, libgdbm-compat-dev,
   tk-dev, blt-dev (>= 2.4z), libssl-dev,
   libexpat1-dev, libmpdec-dev (>= 2.5.1~),
   libbluetooth-dev [linux-any] <!pkg.python3.10.nobluetooth>,

=== debian/rules ===
--- 
+++ 
@@ -80,6 +80,16 @@
 	if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
 	elif dpkg-vendor --derives-from Debian; then echo Debian; \
 	else echo Unknown; fi)
+
+# FIXME: add bullseye when uploading to unstable, after bullseye is released
+ifneq (,$(filter $(distrelase), jessie stretch buster precise trusty xenial bionic focal groovy hirsute))
+  with_dbmmodule = yes
+  bd_dbm = libdb-dev
+  dbmliborder = bdb:gdbm
+else
+  bd_dbm = libgdbm-compat-dev
+  dbmliborder = gdbm:bdb
+endif
 
 VER=3.10
 SVER=3.10.0~a4
@@ -231,14 +241,3 @@
 	-e 's/-fstack-protector /-fstack-protector-strong /g' \
 	-e 's/-specs=[^ ]*//g' \
 	-e 's/-fdebug-prefix-map=[^ ]*//g' \
-	-e 's,^RUNSHARED *=.*,RUNSHARED=,' \
-	-e '/BLDLIBRARY/s/-L\. //'
-
-make_build_target = $(if $(filter yes, $(with_pgo)),profile-opt)
-
-buildd_static	:= $(CURDIR)/build-static
-buildd_shared	:= $(CURDIR)/build-shared
-buildd_debug	:= $(CURDIR)/build-debug
-buildd_shdebug	:= $(CURDIR)/build-shdebug
-
-d		:= debian/tmp

## python3.10 3.10.0

=== debian/changelog ===
python3.10 (3.10.0-2) unstable; urgency=medium

  * ensurepip: Install pkg_resources as well as setuptools (Stefano Rivera).
  * Strip trailing '\n' from file names in py_compile (Graham Inggs).
  * Update ia64 build flags (Adrian Glaubitz). Closes: #995987, #996002.

 -- Matthias Klose <doko@debian.org>  Mon, 11 Oct 2021 07:33:59 +0200

python3.10 (3.10.0-1) unstable; urgency=medium

  * Python 3.10.0 release.
  * Update symbols files.
  * Annotate patches (Stefano Rivera).
  * Use Python 3.10's native --with-wheel-pkg-dir= mechanism (Stefano Rivera).

 -- Matthias Klose <doko@debian.org>  Fri, 08 Oct 2021 14:10:19 +0200

python3.10 (3.10.0~rc2-2) unstable; urgency=medium

  * More flags substitutions for LDFLAGS in _sysconfigdata.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Fri, 24 Sep 2021 11:47:58 +0200

python3.10 (3.10.0~rc2-1) unstable; urgency=medium

  * Python 3.10.0 release candidate 2.
  * Update symbols files.

 -- Matthias Klose <doko@debian.org>  Thu, 09 Sep 2021 11:19:38 +0200

python3.10 (3.10.0~rc1-4) unstable; urgency=medium

  * Fix the test_site test.

 -- Matthias Klose <doko@debian.org>  Mon, 06 Sep 2021 10:17:55 +0200

python3.10 (3.10.0~rc1-3) unstable; urgency=medium

  * Tighten autopkg test dependencies.

 -- Matthias Klose <doko@debian.org>  Sun, 05 Sep 2021 11:32:32 +0200

python3.10 (3.10.0~rc1-2) unstable; urgency=medium

  * Fix path to mkdir on a unified-/usr system. Addresses: #992775.
  * Use command -v instead of which in shell scripts.
  * Also don't run the test_concurrent_futures test on armhf and sparc64.
    Closes: #991111.

 -- Matthias Klose <doko@debian.org>  Fri, 03 Sep 2021 09:33:09 +0200

python3.10 (3.10.0~rc1-1) unstable; urgency=medium

  * Python 3.10.0 release candidate 1.
  * Update symbols files.
  * Fix CFLAGS in the python3.x-config scripts. Addresses: #992669.
  * Support arc-linux-gnu in the multiarch header. Addresses: #992091.
  * Don't run the test_concurrent_futures test on alpha. Addresses: #991110.

 -- Matthias Klose <doko@debian.org>  Thu, 02 Sep 2021 13:49:53 +0200

python3.10 (3.10.0~b4-1) experimental; urgency=medium

  * Python 3.10.0 beta 4 snapshot.

 -- Matthias Klose <doko@debian.org>  Mon, 12 Jul 2021 22:28:24 +0200

python3.10 (3.10.0~b3-1) experimental; urgency=medium

  * Python 3.10.0 beta 3 snapshot.

 -- Matthias Klose <doko@debian.org>  Fri, 18 Jun 2021 08:25:12 +0200

python3.10 (3.10.0~b2-1) experimental; urgency=medium

  * Python 3.10.0 beta 2 snapshot.

 -- Matthias Klose <doko@debian.org>  Fri, 04 Jun 2021 10:45:30 +0200

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
   net-tools, xvfb <!nocheck>, xauth <!nocheck>,
   systemtap-sdt-dev
 Build-Depends-Indep: python3-sphinx, python3-docs-theme, texinfo
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/cpython-team/python3
 Vcs-Git: https://salsa.debian.org/cpython-team/python3.git
 XS-Testsuite: autopkgtest

=== debian/rules ===
--- 
+++ 
@@ -92,7 +92,7 @@
 endif
 
 VER=3.10
-SVER=3.10.0~a4
+SVER=3.10.0
 NVER=3.11
 PVER=python$(VER)
 EXT_VER=$(subst .,,$(VER))
@@ -176,13 +176,12 @@
 OPT_CFLAGS   := $(filter-out -O%,$(DPKG_CFLAGS)) # default is -O3
 DEBUG_CFLAGS := $(patsubst -O%,-Og,$(DPKG_CFLAGS))
 
-# on ia64, disable -O3 until gcc bug #85412 is fixed
 ifeq ($(DEB_HOST_ARCH),ia64)
-    EXTRA_OPT_CFLAGS += -O2
-endif
-# see #972202
-ifeq ($(DEB_HOST_ARCH),sh4)
-    EXTRA_OPT_CFLAGS += -O1
+    DPKG_CPPFLAGS += -DWITH_PYMALLOC_RADIX_TREE=0
+endif
+# see #972202, and https://gcc.gnu.org/PR97431
+ifneq (,$(filter $(DEB_HOST_ARCH), hppa sh4))
+    EXTRA_OPT_CFLAGS += -fno-inline-small-functions
 endif
 ifneq (,$(filter $(DEB_HOST_ARCH), ppc64 ppc64el))
     OPT_CFLAGS += -fexceptions
@@ -204,9 +203,6 @@
 ifneq (,$(findstring nopgo, $(DEB_BUILD_OPTIONS)))
   with_pgo :=
 endif
-
-with_pgo := disabled for now
-with_lto := disabled for now
 
 ifneq (,$(findstring nolto, $(DEB_BUILD_OPTIONS)))
   with_lto :=

=== debian/tests/control ===
--- 
+++ 
@@ -4,9 +4,9 @@
   locales-all,
   python3.10-dev,
   libpython3.10-testsuite:native,
-  python3-gdbm (>= 3.9.0),
+  python3-gdbm (>= 3.9.7),
   python3-distutils,
-  python3-tk (>= 3.9.0),
+  python3-tk (>= 3.9.7),
   idle-python3.10,
   systemtap-sdt-dev,
 # need to turn off apport
@@ -18,10 +18,10 @@
   locales-all, python3.10-dev,
   python3.10-dbg,
   libpython3.10-testsuite:native,
-  python3-gdbm-dbg (>= 3.9.0),
+  python3-gdbm-dbg (>= 3.9.7),
   gdb,
   python3-distutils,
-  python3-tk-dbg (>= 3.9.0),
+  python3-tk-dbg (>= 3.9.7),
   idle-python3.10,
   systemtap-sdt-dev,
 # need to turn off apport
@@ -33,10 +33,10 @@
   locales-all,
   python3.10-dev,
   libpython3.10-testsuite:native,
-  python3-gdbm (>= 3.9.0),
-  python3-tk (>= 3.9.0),
+  python3-gdbm (>= 3.9.7),
+  python3-tk (>= 3.9.7),
   python3-distutils,
-  python3.9-venv,
+  python3.10-venv,
 # need to turn off apport
 Restrictions: needs-root, allow-stderr
 
@@ -47,11 +47,11 @@
   python3.10-dev,
   python3.10-dbg,
   libpython3.10-testsuite:native,
-  python3-gdbm-dbg (>= 3.9.0),
-  python3-tk-dbg (>= 3.9.0),
+  python3-gdbm-dbg (>= 3.9.7),
+  python3-tk-dbg (>= 3.9.7),
   gdb,
   python3-distutils,
-  python3.9-venv,
+  python3.10-venv,
 # need to turn off apport
 Restrictions: needs-root, allow-stderr
